"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepMerge = void 0;
var tslib_1 = require("tslib");
function isObject(item) {
    return item && typeof item === "object" && !Array.isArray(item);
}
function deepMerge(target, source) {
    var output = (0, tslib_1.__assign)({}, target);
    if (isObject(target) && isObject(source)) {
        Object.keys(source).forEach(function (key) {
            var _a, _b;
            var sourceElement = source[key];
            if (isObject(sourceElement)) {
                if (!(key in target)) {
                    Object.assign(output, (_a = {}, _a[key] = sourceElement, _a));
                }
                else {
                    output[key] = deepMerge(target[key], sourceElement);
                }
            }
            else {
                Object.assign(output, (_b = {}, _b[key] = sourceElement, _b));
            }
        });
    }
    return output;
}
exports.deepMerge = deepMerge;
//# sourceMappingURL=deepMerge.js.map